


#ifndef EPM_HANDLER_COMMON
#define EPM_HANDLER_COMMON

#include <epm/epm.h>
#include <string>

#include <vector>
#include <map>


#ifdef __cplusplus
extern "C" {
#endif


	void split(char *src, const char *separator, char **dest, int *num);
	
	int JLCS_05_BOMSendOutSap(EPM_action_message_t msg);
	int JLCS_05_BOMSendOutSap_Single(EPM_action_message_t msg);
	int JLCS_05_BOMUpdateSap_MasterData(EPM_action_message_t msg);
	int JLCS_05_BOMSendOutSap_MasterData(EPM_action_message_t msg);
	int JLCS_05_BOMDeleteSap_MasterData(EPM_action_message_t msg);
	int JL_Send_Mail(EPM_action_message_t msg);
	int Connor_set_bypass(void *returnValue);
	int ORIGIN_close_bypass(void *returnValue);
	int Create_Remodel_Process(void *returnValue);
	int Send_Order_Process(void *returnValue);
	int DMU_Review_Process(void *returnValue);
	int JL_Change_Inspection_Of_Basic_Part(EPM_rule_message_t msg);
	int jl_insert_img_pdf(EPM_action_message_t msg);
	int jl_insert_modular(EPM_action_message_t msg);
	int jl_dmu_auto(EPM_action_message_t msg);
	int jl_locomotion_item(EPM_action_message_t msg);
	int JL_sign_tongzhi(EPM_action_message_t msg);
	int JL_sign_master(EPM_action_message_t msg);
	int ORIGIN_ask_sign_info(tag_t task_node, char *output_str,char *task_name,char *arg3value);
	int JL_Judge_Revision (EPM_action_message_t msg);
	int JL_add_to_referenece(EPM_action_message_t msg);
	int JL_create_process(EPM_action_message_t msg);
	int test (EPM_action_message_t msg);
	int Super_Bom_Appent_Data (void *returnValue);
	int JL_Target_Moveto_Annex(EPM_action_message_t msg);
	int JL_Add_FinishTime(EPM_action_message_t msg);
	int JL_form_save(METHOD_message_t *msg, va_list args);
	int JL_Welding_Syetem(EPM_action_message_t msg);
	int JL_Auto_Order_Process(EPM_action_message_t msg);
	//user service end
#ifdef __cplusplus
}
#endif

#endif 


/**
* @}
*/